---
title: IDBIndex.getKey()
slug: Web/API/IDBIndex/getKey
tags:
  - API
  - Database
  - IDBIndex
  - IndexedDB
  - Method
  - Reference
  - Storage
---
<p>{{ APIRef("IndexedDB") }}</p>

<div>
<p>The <strong><code>getKey()</code></strong> method of the {{domxref("IDBIndex")}} interface returns an {{domxref("IDBRequest")}} object, and, in a separate thread, finds either the primary key that corresponds to the given key in this index or the first corresponding primary key, if <code>key</code> is set to an {{domxref("IDBKeyRange")}}.</p>
</div>

<p>If a primary key is found, it is set as the <code>result</code> of the request object. Note that this doesn't return the whole record as {{domxref("IDBIndex.get")}} does.</p>

<p>{{AvailableInWorkers}}</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox" style="font-size: 14px;">var <em>request</em> = <em>myIndex</em>.getKey(<em>key</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>key {{optional_inline}}</dt>
 <dd>A key or {{domxref("IDBKeyRange")}} that identifies a record to be retrieved. If this value is null or missing, the browser will use an unbound key range.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>An {{domxref("IDBRequest")}} object on which subsequent events related to this operation are fired.</p>

<h3 id="Exceptions"><span style="line-height: 1.5;">Exceptions</span></h3>

<p>This method may raise a {{domxref("DOMException")}} of one of the following types:</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Exception</th>
   <th scope="col">Description</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>TransactionInactiveError</code></td>
   <td>This IDBIndex's transaction is inactive.</td>
  </tr>
  <tr>
   <td><code>DataError</code></td>
   <td>
    <p>The key or key range provided contains an invalid key.</p>
   </td>
  </tr>
  <tr>
   <td><code>InvalidStateError</code></td>
   <td>The IDBIndex has been deleted or removed.</td>
  </tr>
 </tbody>
</table>

<h2 id="Example">Example</h2>

<p>In the following example we open a transaction and an object store, then get the index <code>lName</code> from a simple contacts database. We then open a basic cursor on the index using {{domxref("IDBIndex.openCursor")}} — this works the same as opening a cursor directly on an <code>ObjectStore</code> using {{domxref("IDBObjectStore.openCursor")}} except that the returned records are sorted based on the index, not the primary key.</p>

<p><code>myIndex.getKey('Bungle')</code> is then used to retrieve the primary key of the record with an <code>lName</code> of <code>Bungle</code>, and the result of that request is logged to the console when its success callback returns.</p>

<p>Finally, we iterate through each record, and insert the data into an HTML table. For a complete working example, see our <a href="https://github.com/mdn/indexeddb-examples/tree/master/idbindex">IndexedDB-examples demo repo</a> (<a href="https://mdn.github.io/indexeddb-examples/idbindex">View the example live</a>.)</p>

<pre class="brush: js">function displayDataByIndex() {
  tableEntry.innerHTML = '';
  var transaction = db.transaction(['contactsList'], 'readonly');
  var objectStore = transaction.objectStore('contactsList');

  var myIndex = objectStore.index('lName');
  <span style="font-size: 1rem;">var getKeyRequest = myIndex.getKey('Bungle');</span>
  getKeyRequest.onsuccess = function() {
    console.log(getKeyRequest.result);
  }

  myIndex.openCursor().onsuccess = function(event) {
    var cursor = event.target.result;
    if(cursor) {
      var tableRow = document.createElement('tr');
      tableRow.innerHTML =   '&lt;td&gt;' + cursor.value.id + '&lt;/td&gt;'
                           + '&lt;td&gt;' + cursor.value.lName + '&lt;/td&gt;'
                           + '&lt;td&gt;' + cursor.value.fName + '&lt;/td&gt;'
                           + '&lt;td&gt;' + cursor.value.jTitle + '&lt;/td&gt;'
                           + '&lt;td&gt;' + cursor.value.company + '&lt;/td&gt;'
                           + '&lt;td&gt;' + cursor.value.eMail + '&lt;/td&gt;'
                           + '&lt;td&gt;' + cursor.value.phone + '&lt;/td&gt;'
                           + '&lt;td&gt;' + cursor.value.age + '&lt;/td&gt;';
      tableEntry.appendChild(tableRow);

      cursor.continue();
    } else {
      console.log('Entries all displayed.');
    }
  };
};</pre>

<h2 id="Specification"><span style="font-size: 2.14285714285714rem;">Specification</span></h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('IndexedDB', '#dom-idbindex-getkey', 'getKey()')}}</td>
   <td>{{Spec2('IndexedDB')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName("IndexedDB 2", "#dom-idbindex-getkey", "getKey()")}}</td>
   <td>{{Spec2("IndexedDB 2")}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.IDBIndex.getKey")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/IndexedDB_API/Using_IndexedDB">Using IndexedDB</a></li>
 <li>Starting transactions: {{domxref("IDBDatabase")}}</li>
 <li>Using transactions: {{domxref("IDBTransaction")}}</li>
 <li>Setting a range of keys: {{domxref("IDBKeyRange")}}</li>
 <li>Retrieving and making changes to your data: {{domxref("IDBObjectStore")}}</li>
 <li>Using cursors: {{domxref("IDBCursor")}}</li>
 <li>Reference example: <a class="external" href="https://github.com/mdn/to-do-notifications/tree/gh-pages">To-do Notifications</a> (<a class="external" href="https://mdn.github.io/to-do-notifications/">view example live</a>.)</li>
</ul>
